<?php

/* -> index.php/registration/... */

class Registration extends Controller {
    /* -> index.php/registration/index */

    public function index() {
        $this->loader->load();
    }

    /* -> index.php/registration/registrations */
    public function registrations() {
        /*$data['registrations'] = $this->registration->registrations();*/
        $sort = '';
        if(isset($_POST['cours'])){
            $sort = "WHERE courses.name='".$_POST['cours']."' ";
        }
        $data = ['registrations' => $this->registration->registrations($sort), 'courses' => $this->registration->courses()];
        $this->loader->load('registration_list', $data);
    }

    /* Les autres actions. */

    //!-- registrations_new --
    /* -> index.php/registration/registrations_new */
    public function registrations_new() {
        $data = ['courses' => $this->registration->courses()];
        $this->loader->load('registration_form', $data);
    }


    //!-- unregister --
    /* -> index.php/registration/unregister */
    public function unregister() {
        if(isset($_POST['firstname']) and isset($_POST['lastname'])){
            $this->registration->unregister_student($_POST['firstname'], $_POST['lastname']);
        }       
        $this->registrations();
    }

    //!-- end registrations_new --
    
    //!-- registrations_create --
    const FORM_FILTERS = [
        'firstname' =>
        [
            'filter' => FILTER_VALIDATE_REGEXP,
            'flags' => FILTER_NULL_ON_FAILURE,
            'options' => ['regexp' => '/^[A-Za-z\' -]{1,20}$/'],
            'message' => 'Le prénom doit etre alphaNum'
        ],
        'lastname' =>
        [
            'filter' => FILTER_VALIDATE_REGEXP,
            'flags' => FILTER_NULL_ON_FAILURE,
            'options' => ['regexp' => '/^[A-Za-z\' -]{1,20}$/'],
            'message' => 'Le prénom doit etre alphaNum'
        ],
        'courses' => [
            'filter' => FILTER_VALIDATE_INT,
            'flags' => FILTER_REQUIRE_ARRAY,
            'options' => ['min_range' => 1, 'max_range' => 6],
            'message' => 'Vous devez choisir au moins un cours'
        ]
    ];

    public function registrations_create() {
        $form_data = filter_input_array(INPUT_POST, self::FORM_FILTERS, true);
        $error = $this->compute_error($form_data, self::FORM_FILTERS);
        if ($error !== false) {
            $data = ['courses' => $this->registration->courses(),
                'error' => $error];
            $this->loader->load('registration_form', $data);
            return;
        }
        /* sauvegarde dans le modele et choix d'une vue */
        $this->registration->register(
                $form_data['firstname'], $form_data['lastname'], $form_data['courses']);
        $this->registrations(); // Bonne idée ???
    }

    //!-- end registrations_create --
}
